Video for Linux Two API Specification: Revision 0.24
Prev |  | Next

# ioctl VIDIOC_ENUM_FMT

## Name

VIDIOC_ENUM_FMT -- Enumerate image formats

## Synopsis

``int ioctl`(int fd, int request, struct v4l2_fmtdesc *argp);`

## Arguments

`fd`

  File descriptor returned by `open()`.

`request`

  VIDIOC_ENUM_FMT

`argp`

## Description

To enumerate image formats applications initialize the `type` and `index` field of struct v4l2_fmtdesc and call the `VIDIOC_ENUM_FMT` ioctl with a pointer to this structure. Drivers fill the rest of the structure or return an EINVAL error code. All formats are enumerable by beginning at index zero and incrementing by one until EINVAL is returned.

Table 1. struct `v4l2_fmtdesc`

__u32 | `index` | Number of the format in the enumeration, set by the application. This is in no way related to the `pixelformat` field.
enum v4l2_buf_type | `type` | Type of the data stream, set by the application. Only these types are valid here: `V4L2_BUF_TYPE_VIDEO_CAPTURE`, `V4L2_BUF_TYPE_VIDEO_OUTPUT`, `V4L2_BUF_TYPE_VIDEO_OVERLAY`, and custom (driver defined) types with code `V4L2_BUF_TYPE_PRIVATE` and higher.
__u32 | `flags` | See Table 2
__u8 | `description`[32] | Description of the format, a NUL-terminated ASCII string. This information is intended for the user, for example: "YUV 4:2:2".
__u32 | `pixelformat` | The image format identifier. This is a four character code as computed by the v4l2_fourcc() macro:

    #define v4l2_fourcc(a,b,c,d) (((__u32)(a)<<0)|((__u32)(b)<<8)|((__u32)(c)<<16)|((__u32)(d)<<24))

Several image formats are already defined by this specification in Chapter 2. Note these codes are not the same as those used in the Windows world.

__u32 | `reserved`[4] | Reserved for future extensions. Drivers must set the array to zero.

Table 2. Image Format Description Flags

`V4L2_FMT_FLAG_COMPRESSED` | 0x0001 | This is a compressed format.

## Return Value

On success 0 is returned, on error -1 and the `errno` variable is set appropriately:

EINVAL

  The struct v4l2_fmtdesc `type` is not supported or the `index` is out of bounds.

Prev | Home | Next
ioctl VIDIOC_ENUMAUDOUT | Up | ioctl VIDIOC_ENUM_FRAMESIZES